Imports System
Imports System.Collections

Public Module modHelpers

   Public Function EnumGetName(Of T As Structure)(ByVal Value As T) As String
      Return [Enum].GetName(GetType(T), Value)
    End Function

    Public Sub ExchangeDisposable(Of T As IDisposable, T2 As T)(ByRef Dest As T, ByVal Src As T2)
        If Dest IsNot Nothing Then Dest.Dispose()
        Dest = Src
    End Sub

    Public Sub DisposeManaged(Of T As IDisposable)(ByRef Disposable As T)
        If Disposable Is Nothing Then Return
        Disposable.Dispose()
    End Sub

   Public Function ClipBetween(Of T As IComparable)( _
         ByVal Bord0 As T, _
         ByVal ToTest As T, _
         ByVal Bord1 As T) As T
      If Bord0.CompareTo(ToTest) > 0 Then Return Bord0
      If Bord1.CompareTo(ToTest) < 0 Then Return Bord1
      Return ToTest
   End Function

   ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
   Public Sub Dbg(ByVal ParamArray Args As Object())
      Dim Args2(Args.Length * 2 - 1) As Object
      For i As Integer = 0 To Args.Length - 1
         Args2(i * 2) = Args(i)
         Args2(i * 2 + 1) = " "
      Next
      Console.WriteLine(String.Concat(Args2))
   End Sub

   ''' <summary>
   ''' Ermittelt die typisierte Row eines als Object bergebenen DataRowViews
   ''' Bsp: Name = GetRow(Of OrderDataset.CustomerRow)(CustomerBindingSource.Current).Name
   ''' </summary>
   Public Function GetRow(Of T As DataRow)(ByVal Current As Object) As T
      If Current Is Nothing Then Return Nothing
      Return DirectCast(DirectCast(Current, DataRowView).Row, T)
   End Function

End Module
