'IDE-Voreinstellungen:
'Option Explicit On
'Option Strict On

'"My Project"-Einstellungen:
'Imports Microsoft.VisualBasic.ControlChars
'Imports System.Windows.Forms

Imports System.ComponentModel

''' <summary>kapselt ein quadratisches DataGridView</summary>
Public Class uclMatrixGrid

   Private ReadOnly _EdgeSize As Integer

   Public Sub New()
      InitializeComponent()
      _EdgeSize = Me.Grid.ColumnCount
      Me.Grid.RowCount = _EdgeSize
   End Sub

   ''' <summary>Werte als eindimensionales Array</summary>
   ''' <remarks>datenbindebar und speicherfhig</remarks>
   <Bindable(True)> _
   Public Property Bytes() As SByte()
      Get
         Dim RetVal(_EdgeSize * _EdgeSize - 1) As SByte
         For Y As Integer = 0 To _EdgeSize - 1
            For X As Integer = 0 To _EdgeSize - 1
               RetVal(Y * _EdgeSize + X) = CSByte(Me.Grid(X, Y).Value)
            Next
         Next
         Return RetVal
      End Get
      Set(ByVal NewValue As SByte())
         Dim Line(_EdgeSize - 1) As Object
         For Y As Integer = 0 To _EdgeSize - 1
            For X As Integer = 0 To _EdgeSize - 1
               Me.Grid(X, Y).Value = NewValue(Y * _EdgeSize + X)
            Next
         Next
      End Set
   End Property

   ''' <summary>Werte als zweidimensionales Array</summary>
   ''' <remarks>verwendbar fr Berechnungen</remarks>
   Public Function GetMatrix() As SByte(,)
      Dim RetVal(_EdgeSize - 1, _EdgeSize - 1) As SByte
      For Y As Integer = 0 To _EdgeSize - 1
         For X As Integer = 0 To _EdgeSize - 1
            RetVal(Y, X) = CSByte(Me.Grid(X, Y).Value)
         Next
      Next
      Return RetVal
   End Function

   Private Sub Grid_CellPainting( _
         ByVal sender As Object, ByVal e As DataGridViewCellPaintingEventArgs) _
         Handles Grid.CellPainting
        'stellt die Spaltenberschriften auch auf den Zeilenkpfen dar
      With Grid
         'Die Zeilenkpfe werden mit ColumnIndex=-1 angesprochen 
         If e.ColumnIndex < 0 AndAlso e.RowIndex >= 0 AndAlso e.RowIndex < .RowCount Then
            e.PaintBackground(e.CellBounds, False)
            TextRenderer.DrawText( _
                e.Graphics, _
                .Columns(e.RowIndex).HeaderText, _
                .Font, _
                e.CellBounds, _
                .ForeColor)
            e.Handled = True
         End If
      End With
   End Sub

End Class
